using FLY.OBJComponents.Client;
using FLY.OBJComponents.Common;
using Misc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Thick.Base.UI
{
    /// <summary>
    /// Page_Flow.xaml 的交互逻辑
    /// </summary>
    public partial class PgErrorAllTable : Page
    {
        FLY.OBJComponents.IService.IWarningService warningService;
        BufferWindow<FlyData_WarningHistory> mWindow;
        ParamDictionary paramDictionary;
        /// <summary>
        /// 
        /// </summary>
        public PgErrorAllTable()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="warningService"></param>
        /// <param name="paramDictionary"></param>
        [InjectionMethod]
        public void Init(
            FLY.OBJComponents.IService.IWarningService warningService,
            ParamDictionary paramDictionary)
        {
            this.warningService = warningService;
            this.paramDictionary = paramDictionary;

            //窗口显示数据条数
            int windowSize = this.paramDictionary.GetValue<int>(ParamDistItemKeys.WindowSize, 30);
            mWindow = new BufferWindow<FlyData_WarningHistory>(this.warningService.NewestList, windowSize);

            mWindow.PropertyChanged += (s, e) =>
            {
                if (e.PropertyName == "Size")
                {
                    this.paramDictionary.SetValue(ParamDistItemKeys.WindowSize, mWindow.Size);
                }
            };

            grid_window.DataContext = mWindow;
        }


        private void button_back_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.GoBack();
        }

        private void button_clear_click(object sender, RoutedEventArgs e)
        {
            if (FLY.ControlLibrary.MyMessageBox.Show("确定是否清空全部历史数据?") == true)
            {
                warningService.NewestList.Reset();
                FLY.ControlLibrary.Window_Tip.Show("成功", "清除完毕!", TimeSpan.FromSeconds(2));
            }
        }

        private void button_prepage_Click(object sender, RoutedEventArgs e)
        {
            mWindow.MovePrePage();
        }

        private void button_nextpage_Click(object sender, RoutedEventArgs e)
        {
            mWindow.MoveNextPage();
        }

        private void button_newest_Click(object sender, RoutedEventArgs e)
        {
            mWindow.MoveNewest();
        }
    }
}
